///////////////////////
/* VistaElevator\DLL.cpp

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (C) 2007.  WinAbility Software Corporation. All rights reserved.

Author: Andrei Belogortseff [ http://www.tweak-uac.com ]

TERMS OF USE: You are free to use this file in any way you like, 
for both the commercial and non-commercial purposes, royalty-free,
AS LONG AS you agree with the warranty disclaimer above, 
EXCEPT that you may not remove or modify this or any of the 
preceeding paragraphs. If you make any changes, please document 
them in the MODIFICATIONS section below. If the changes are of general 
interest, please let us know and we will consider incorporating them in 
this file, as well.

SUMMARY:

Make sure you have the latest Windows SDK (see msdn.microsoft.com for more information) 
or this file may not compile!

This file contains a demo application that illustrates the use of the functions 
specified in the VistaTools.cxx file.

It uses TaskDialog for its user interface, that gives the user two choices how to restart itself:
as an elevated process, or as a limited (non-elevated) one. This way, you can see in action how a 
non-elevated process starts an elevated one, and vica versa. 

MODIFICATIONS:
	2007-Feb-16: created by Andrei Belogortseff.
*/

#define NTDDI_VERSION NTDDI_LONGHORN

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <commctrl.h>
#include <objbase.h>
#include <CRTDBG.H>
#include <shlwapi.h>
#include <shellapi.h>

#include <strsafe.h>

#define IMPLEMENT_VISTA_TOOLS
#include "VistaTools.cxx"

#include "DLL-res.h"

#ifndef TRACK_LEAKS
#	ifndef _DEBUG
#		define TRACK_LEAKS	__noop
#	else
#		define TRACK_LEAKS() _CrtSetDbgFlag( _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG ) | _CRTDBG_LEAK_CHECK_DF )
#	endif //_DEBUG
#endif	//TRACK_LEAKS

#pragma comment(lib, "comctl32.lib")

////////////////////////////////////////////////////////////
// the handle to the DLL module, needed to install the hook 

//HINSTANCE hiDLL = NULL;

////////////////////////////
// a standard DLL stub

BOOL APIENTRY DllMain( HMODULE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		//hiDLL = hModule;
		TRACK_LEAKS();
		::DisableThreadLibraryCalls( hModule );
		break;
	}

    return TRUE;
}

